<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "manual_validation".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ManualValidation".
 *
 * Columns in table "manual_validation" available as properties of the model,
 * followed by relations of table "manual_validation" available as properties of the model.
 *
 * @property integer $id
 * @property integer $account_id
 * @property string $provider_id
 * @property string $practice_id
 * @property string $first_name
 * @property string $last_name
 * @property string $npi_number
 * @property integer $specialty_id
 * @property integer $sub_specialty_id
 * @property string $address
 * @property integer $location_id
 * @property string $email
 * @property string $phone_number
 * @property string $practice_name
 * @property string $status
 * @property string $status_rejected_reason
 * @property string $validation_type
 * @property string $status_comments
 * @property string $source
 * @property string $date_added
 * @property string $date_updated
 * @property string $address_2
 * @property string $gender
 * @property integer $admin_account_id
 *
 * @property IdpRequestLog[] $idpRequestLogs
 * @property Location $location
 * @property Account $adminAccount
 * @property Account $account
 */
abstract class BaseManualValidation extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'manual_validation';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ManualValidation|ManualValidations', $n);
    }

    public static function representingColumn()
    {
        return 'last_name';
    }

    public function rules()
    {
        return array(
            array('last_name, location_id, date_updated', 'required'),
            array(
                'account_id, specialty_id, sub_specialty_id, location_id, admin_account_id',
                'numerical',
                'integerOnly' => true
            ),
            array('provider_id, practice_id', 'length', 'max'=>11),
            array('first_name', 'length', 'max'=>50),
            array('last_name, address, practice_name, address_2', 'length', 'max'=>80),
            array('npi_number', 'length', 'max'=>10),
            array('email', 'length', 'max'=>254),
            array('phone_number', 'length', 'max'=>14),
            array('status, status_rejected_reason, source, gender', 'length', 'max'=>1),
            array('validation_type', 'length', 'max'=>8),
            array('status_comments, date_added', 'safe'),
            array(
                'account_id, provider_id, practice_id, first_name, npi_number, specialty_id, sub_specialty_id, address,
                    email, phone_number, practice_name, status, status_rejected_reason, validation_type,
                    status_comments, source, date_added, address_2, gender, admin_account_id',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, account_id, provider_id, practice_id, first_name, last_name, npi_number, specialty_id,
                    sub_specialty_id, address, location_id, email, phone_number, practice_name, status,
                    status_rejected_reason, validation_type, status_comments, source, date_added, date_updated,
                    address_2, gender, admin_account_id',
                'safe',
                'on'=>'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'idpRequestLogs' => array(self::HAS_MANY, 'IdpRequestLog', 'manual_validation_id'),
            'location' => array(self::BELONGS_TO, 'Location', 'location_id'),
            'adminAccount' => array(self::BELONGS_TO, 'Account', 'admin_account_id'),
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_id' => null,
            'provider_id' => Yii::t('app', 'Provider'),
            'practice_id' => Yii::t('app', 'Practice'),
            'first_name' => Yii::t('app', 'First Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'npi_number' => Yii::t('app', 'Npi Number'),
            'specialty_id' => Yii::t('app', 'Specialty'),
            'sub_specialty_id' => Yii::t('app', 'Sub Specialty'),
            'address' => Yii::t('app', 'Address'),
            'location_id' => null,
            'email' => Yii::t('app', 'Email'),
            'phone_number' => Yii::t('app', 'Phone Number'),
            'practice_name' => Yii::t('app', 'Practice Name'),
            'status' => Yii::t('app', 'Status'),
            'status_rejected_reason' => Yii::t('app', 'Status Rejected Reason'),
            'validation_type' => Yii::t('app', 'Validation Type'),
            'status_comments' => Yii::t('app', 'Status Comments'),
            'source' => Yii::t('app', 'Source'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'address_2' => Yii::t('app', 'Address 2'),
            'gender' => Yii::t('app', 'Gender'),
            'admin_account_id' => null,
            'idpRequestLogs' => null,
            'location' => null,
            'adminAccount' => null,
            'account' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('provider_id', $this->provider_id, true);
        $criteria->compare('practice_id', $this->practice_id, true);
        $criteria->compare('first_name', $this->first_name, true);
        $criteria->compare('last_name', $this->last_name, true);
        $criteria->compare('npi_number', $this->npi_number, true);
        $criteria->compare('specialty_id', $this->specialty_id);
        $criteria->compare('sub_specialty_id', $this->sub_specialty_id);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('location_id', $this->location_id);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('phone_number', $this->phone_number, true);
        $criteria->compare('practice_name', $this->practice_name, true);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('status_rejected_reason', $this->status_rejected_reason, true);
        $criteria->compare('validation_type', $this->validation_type, true);
        $criteria->compare('status_comments', $this->status_comments, true);
        $criteria->compare('source', $this->source, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('address_2', $this->address_2, true);
        $criteria->compare('gender', $this->gender, true);
        $criteria->compare('admin_account_id', $this->admin_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
